unit ppMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, Db, DBTables, StdCtrls, ExtCtrls, DBCtrls, Mask;

type
  TppMainPerso = class(TForm)
    Element: TLabel;
    ID: TLabel;
    Nom: TLabel;
    btnAjouter: TButton;
    btnFin: TButton;
    btnImprimePerso: TButton;
    btnImprimeTresor: TButton;
    btnImprimeVillage: TButton;
    btnNouvelleTable: TButton;
    btnPerso: TButton;
    btnPrintRencontre: TButton;
    btnRafraichir: TButton;
    btnRencontre: TButton;
    btnTresor: TButton;
    btnVillage: TButton;
    dbePersoNonImprime: TDBEdit;
    dbgMaster: TDBGrid;
    dbgSlave: TDBGrid;
    dbnEsclave: TDBNavigator;
    dbnMaster: TDBNavigator;
    dtsCount: TDataSource;
    dtsMaster: TDataSource;
    dtsPerso: TDataSource;
    dtsRencontre: TDataSource;
    dtsShell: TDataSource;
    dtsSlave: TDataSource;
    dtsTresor: TDataSource;
    dtsVillage: TDataSource;
    edtElem: TEdit;
    edtID: TEdit;
    edtNom: TEdit;
    edtProba: TEdit;
    lblProba: TLabel;
    lblToPrint: TLabel;
    memPerso: TMemo;
    queCount: TQuery;
    queRun: TQuery;
    tblMaster_: TTable;
    tblMaster_Id: TStringField;
    tblMaster_NbrElement: TFloatField;
    tblMaster_Nom: TStringField;
    tblMaster_TotProba: TFloatField;
    tblPerso_: TTable;
    tblPerso_DateCreation: TDateField;
    tblPerso_DateImprime: TStringField;
    tblPerso_Id: TFloatField;
    tblPerso_Perso: TMemoField;
    tblPerso_Sexe_Cel_Mel_Stat: TStringField;
    tblRencontre_: TTable;
    tblRencontre_DateCreation: TDateField;
    tblRencontre_DateImprime: TStringField;
    tblRencontre_Id: TFloatField;
    tblRencontre_Rencontre: TMemoField;
    tblRencontre_Type: TStringField;
    tblSlave_: TTable;
    tblSlave_Element: TStringField;
    tblSlave_ID: TStringField;
    tblSlave_Proba: TFloatField;
    tblTresor_: TTable;
    tblTresor_DateCreation: TDateField;
    tblTresor_DateImprime: TStringField;
    tblTresor_Id: TFloatField;
    tblTresor_Tresor: TMemoField;
    tblTresor_Type: TStringField;
    tblVillage_: TTable;
    tblVillage_Id: TFloatField;
    tblVillage_Village: TMemoField;
    tblVillage_DateImprime: TStringField;
    tblVillage_Type: TStringField;
    tblVillage_DateCreation: TDateField;
    procedure btnFinClick(Sender: TObject);
    procedure btnNouvelleTableClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnAjouterClick(Sender: TObject);
    procedure AjouterElement(sTab:string; sElem : string; sProba : string);
    procedure dbgMasterCellClick(Column: TColumn);
    procedure tblMaster_BeforeDelete(DataSet: TDataSet);
    procedure tblMaster_AfterDelete(DataSet: TDataSet);
    procedure dbgMasterColumnMoved(Sender: TObject; FromIndex,
      ToIndex: Integer);
    procedure dbgMasterColEnter(Sender: TObject);
    procedure SlaveRefresh;
    procedure dbnMasterClick(Sender: TObject; Button: TNavigateBtn);
    procedure dbgMasterKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnPersoClick(Sender: TObject);
    function D(iRange : integer):integer;
    function D4:integer;
    function PP(sTable : string):string;
    procedure tblSlave_BeforeDelete(DataSet: TDataSet);
    procedure btnImprimePersoClick(Sender: TObject);
    procedure tblSlave_AfterEdit(DataSet: TDataSet);
    procedure btnRafraichirClick(Sender: TObject);
    procedure btnTresorClick(Sender: TObject);
    procedure btnImprimeTresorClick(Sender: TObject);
    procedure btnRencontreClick(Sender: TObject);
    procedure btnPrintRencontreClick(Sender: TObject);
    procedure btnVillageClick(Sender: TObject);
    procedure btnImprimeVillageClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ppMainPerso: TppMainPerso;

implementation

uses ppReport, ppReportTresor, ppReportRencontre, ppReportVillage;

{$R *.DFM}

(**************************************************************************)
{sortie du programme}
procedure TppMainPerso.btnFinClick(Sender: TObject);
begin
  tblMaster_.close;
  tblSlave_.close;
  tblPerso_.close;
  tblTresor_.close;
  tblRencontre_.close;
  tblVillage_.close;
  Application.Terminate;
end;

(**************************************************************************)
{rajout d'une entre dans ppMaster comme nouvelle dfinition de table}
procedure TppMainPerso.btnNouvelleTableClick(Sender: TObject);
begin
  if (edtID.Text<>'') and (edtNom.Text<>'') then begin
    if tblMaster_.Findkey([edtID.Text]) then begin
      ShowMessage('Cette table existe dj !');
    end else begin {cration du record}
      tblMaster_.Append;
      tblMaster_.FieldByName('ID').asString := edtID.Text;
      tblMaster_.FieldByName('Nom').asString := edtNom.Text;
      tblMaster_.FieldByName('NbrElement').asInteger := 0;
      tblMaster_.FieldByName('TotProba').asInteger := 0;
      tblMaster_.post;
      edtID.Text := '';
      edtNom.Text := '';
      edtElem.setFocus; {focus sur l'introduction d'lments}
    end;
  end else begin
    ShowMessage('Entrez des valeurs !');
  end;
end;

(**************************************************************************)
{ouverture des tables principales et de la query de comptage}
procedure TppMainPerso.FormCreate(Sender: TObject);
begin
  tblMaster_.open;
  tblSlave_.open;
  tblPerso_.open;
  tblTresor_.open;
  tblRencontre_.open;
  tblVillage_.open;
  queCount.open;
  ppMainPerso.Top := 0; {placement de la fentre}
  ppMainPerso.Left := 0;
  ppMainPerso.width := 1000;
  ppMainPerso.height := 700;

  Randomize;
end;

(**************************************************************************)
{ajout d'un record dans la table ppSlave, conditions}
procedure TppMainPerso.btnAjouterClick(Sender: TObject);
begin
{si Master active and RecNo > 0 alors reprendre l'ID et ajouter l'lment}
  if tblMaster_.Active then begin
    if tblMaster_.RecNo > 0 then begin
      if (edtElem.Text <> '') and (edtProba.Text <> '') then begin
        AjouterElement(tblMaster_Id.asString, edtElem.text, edtProba.text);
      end else begin
        ShowMessage('Entrez des valeurs pour cet lment!');
      end;
    end else begin
      ShowMessage ('Pas de table slectionne... ');
    end;
  end else begin
    ShowMessage ('Table matre inactive... ');
  end;
  edtElem.setFocus;

end;

(**************************************************************************)
{ajout de l'lment dans ppSlave}
procedure TppMainPerso.AjouterElement(sTab:string; sElem : string; sProba : string);
var
  p : integer;
  i : integer;
  sFilter : string;
begin
  tblSlave_.IndexName := 'siSlave';
  if tblSlave_.Findkey([sTab,sElem]) then begin
    ShowMessage('Cet lment existe dj !');
  end else begin  {prpare le filtre}
    tblSlave_.IndexName := '';
    sFilter := 'ID = ' + '''' + sTab + '''';
    tblSlave_.Filter := sFilter ;
    tblSlave_.Filtered := TRUE;
    try
    {sauve le nouvel lment et nettoie les zones d'entre}
      p  := StrToInt(sProba);
      tblSlave_.Append;
      tblSlave_.FieldByName('ID').asString := sTab;
      tblSlave_.FieldByName('Element').asString := sElem;
      tblSlave_.FieldByName('Proba').asinteger := p;
      tblSlave_.Post;
      edtElem.text := '';
      edtProba.text := '';
      {calcul de la probabilit cumule et du nombre d'lments}
      tblMaster_.Edit;
      i := tblMaster_totProba.asInteger;
      i := i + p;
      tblMaster_.FieldByName('TotProba').asInteger := i;
      i := tblMaster_nbrElement.asInteger;
      inc(i);
      tblMaster_.FieldByName('nbrElement').asInteger := i;
      tblMaster_.Post;

    except
      on EConvertError do ShowMessage('Probabilit incorrecte !');
    end;
  end;
end;

(**************************************************************************)
{afficher les nouveaux lment de la table actuelle}
procedure TppMainPerso.dbgMasterCellClick(Column: TColumn);
begin
  SlaveRefresh;
end;


(**************************************************************************)
{veiller  supprimer les lments dans tblSlave}
procedure TppMainPerso.tblMaster_BeforeDelete(DataSet: TDataSet);
begin
  with queRun,SQL do begin
    Close;
    Clear;
    Add('DELETE FROM ppSlave WHERE id = ' + quotedStr(tblMaster_ID.asString) );
    ExecSql;
  end;
  tblSlave_.Refresh;
end;

(**************************************************************************)
{rafrachit les valeurs}
procedure TppMainPerso.tblMaster_AfterDelete(DataSet: TDataSet);
begin
  tblSlave_.Refresh;
end;

(**************************************************************************)
{rafrachit les valeurs aprs changement de colonne}
procedure TppMainPerso.dbgMasterColumnMoved(Sender: TObject; FromIndex,
  ToIndex: Integer);
begin
  SlaveRefresh;
end;

(**************************************************************************)
{rafrachit les valeurs aprs modification du Master}
procedure TppMainPerso.dbgMasterColEnter(Sender: TObject);
begin
  SlaveRefresh;
end;

(**************************************************************************)
{replace le filtre Master-Slave}
procedure TppMainPerso.SlaveRefresh;
var
  sFilter : string;
begin
    tblSlave_.IndexName := '';
    sFilter := 'ID = ' + '''' + tblMaster_Id.asString + '''';
    tblSlave_.Filter := sFilter ;
    tblSlave_.Filtered := TRUE;
end;

(**************************************************************************)
{rafrachit les valeurs aprs un clic sur ppMaster}
procedure TppMainPerso.dbnMasterClick(Sender: TObject; Button: TNavigateBtn);
begin
  SlaveRefresh;
end;

(**************************************************************************)
{rafrachit les valeurs aprs une touche sur ppMaster}
procedure TppMainPerso.dbgMasterKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  SlaveRefresh;
end;

(**************************************************************************)
{procdure principale de cration de personnage}
procedure TppMainPerso.btnPersoClick(Sender: TObject);
var
  sSpec : string;
  sAge, sCEL, sMEL, sStat : string;
  iCle : integer;
  i, iNcbt, iNskl : integer;
begin
  iNcbt := 0;
  iNskl := 0;
  queCount.SQL.Clear;
  queCount.SQL.Add('SELECT COUNT(*) as NonImprime FROM ppPerso WHERE DateImprime IS NULL');
  queCount.Close;
  dbgMaster.Visible := FALSE;
  dbgSlave.Visible := FALSE;
  dbgSlave.Enabled := FALSE;
  dbgMaster.Enabled := FALSE;
  memPerso.Clear;
  with memPerso.Lines do begin
    iCle := tblPerso_.RecordCount;
    Add ('                                          ' +
         'PP -'+ IntToStr(iCle) + '- ' + DateToStr(Date)) ;
    sAge := PP('age');
    sCEL := PP('cel');
    sMEL := PP('mel');
    Add ( '_________ ________ _________'
       + ' AGE:' + sAge
       + ' SEXE:' + PP('sexe')
       + ' CEL:' + sCEL
       + ' / MEL:' +sMEL );
    Add (' SOCIAL:' + PP('rich')
       + ' ORIGINE:' + PP('orig')
       + ' PAYS:' + PP('pays')
       + ' LIEU:' + PP('lieu')
       + ' TERRAIN:' + PP('terr')
       + ' CIVIL:' + PP('etci')
       + ' RELIGION:' + PP('reli') );
    sSpec := 'CARACTERE: ';
    if D(5) = 1 then sSpec := sSpec + PP('brav') + '-';
    if D(5) = 1 then sSpec := sSpec + PP('disp') + '-';
    if D(5) = 1 then sSpec := sSpec + PP('econ') + '-';
    if D(5) = 1 then sSpec := sSpec + PP('ener') + '-';
    if D(5) = 1 then sSpec := sSpec + PP('honn') + '-';
    if D(5) = 1 then sSpec := sSpec + PP('mate') + '-';
    if D(5) = 1 then sSpec := sSpec + PP('mora') + '-';
    if D(5) = 1 then sSpec := sSpec + PP('perb') + '-';
    if D(5) = 1 then sSpec := sSpec + PP('perc') + '-';
    if D(5) = 1 then sSpec := sSpec + PP('pers') + '-';
    if D(5) = 1 then sSpec := sSpec + PP('natu') + '-';
    if D(5) = 1 then sSpec := sSpec + PP('piet') + '-';
    if D(5) = 1 then sSpec := sSpec + PP('tena') + '-';
    if D(5) = 1 then sSpec := sSpec + PP('tenb') + '-';
    Add (' CARRURE:' + PP('carr')
       + ' TAILLE:' + PP('tail')
       + ' POIDS:' + PP('poid') );
    Add (' CHEVEUX ' + PP('chco') + ' ' + PP('chlo') + ' ' + PP('chty')
       + ' YEUX:' + PP('yeux')
       + ' PILOSITE TETE:' + PP('pilo') + ' CORPS:' + PP('pico') );

    Add ('s:'+PP('stat')+' - ' +'st:'+PP('stat')+' - ' +'d:'+PP('stat')+' - ' +'a:'+PP('stat')+' - ' +
         'i:'+PP('stat')+' - ' +'w:'+PP('stat')+' - ' +'e:'+PP('stat')+' - ' +'em:'+PP('stat')+' - ' +
         'c:'+PP('stat')+' - ' +'ap:'+PP('stat') );
    Add (sSpec);

    {nombre : talents de combat d(CEL)+2 }
    case sCEL[1] of
      '0' : iNcbt :=  D(2) ;
      '1' : iNcbt :=  D(8) + 3;
      '3' : iNcbt :=  D(4) + 1;
      '7' : iNcbt :=  D(6) + 2;
    end;
    sSPec := 'ARMES : ';
    for i := 1 to iNcbt do begin
      if D(3) = 1 then begin     {choix entre arme de jet et de contact}
        sSpec := sSpec + PP('arje') + '__ / ' ;
      end else begin
        sSpec := sSpec + PP('arco') + '__ / ' ;
      end;
    end;
    Add (sSpec);

    {nombre : talents normaux d(age/10) + (age/20) }
    case sAge[1] of
      '1' : iNskl :=  D(1) + 1;
      '2' : iNskl :=  D(2) + 1;
      '3' : iNskl :=  D(3) + 2;
      '4' : iNskl :=  D(4) + 2;
      '5' : iNskl :=  D(5) + 3;
      '6' : iNskl :=  D(6) + 3;
      '7' : iNskl :=  D(7) + 4;
    end;
    sSPec := 'TALENTS : ';
    for i := 1 to iNskl do begin
      sSpec := sSpec + PP('tale') + '___ / ' ;
    end;
    Add (sSpec);

  end;
  memPerso.Refresh;
  dbgSlave.Visible := TRUE;
  dbgMaster.Visible := TRUE;
  tblPerso_.Append;
  tblPerso_.FieldByName('ID').asInteger := iCle;
  tblPerso_.FieldByName('Perso').asString := memPerso.Text;
  tblPerso_.FieldByName('DateCreation').asDateTime := Now;
  sSpec := sAge + '/' + sCEL + '/' + sMEL + '/' +sStat;
  tblPerso_.FieldByName('Sexe_Cel_Mel_Stat').asString := sSpec;
  tblPerso_.Post;
  queCount.Open;
end;

(**************************************************************************)
{procdure principale de recherche d'un lment dans une table donne}
function TppMainPerso.PP(sTable : string):string;
var
  iChoix : integer;
  iTotProba : integer;
begin
  dbgSlave.DataSource := dtsShell;
  if tblMaster_.Findkey([sTable]) then begin
    if tblMaster_nbrElement.asInteger > 0 then begin
      iChoix := D(tblMaster_totProba.asInteger);    {initialisation}
      SlaveRefresh;
      iTotProba := tblSlave_Proba.asInteger; {premier lment}
      while (iTotProba < iChoix) do begin
        tblSlave_.Next;
        iTotProba := iTotProba + tblSlave_Proba.asInteger; {cumul des proba}
      end;
      PP := tblSlave_Element.asString; {attribution de l'lment choisit}
    end else begin
      ShowMessage ('Aucun lment dans la table "' + sTable + '"');
    end;
  end else begin
    ShowMessage('Pas de table "' + sTable + '"');
  end;
  dbgSlave.DataSource := dtsSlave;
end;

(**************************************************************************)
{fonction du jet d'un d}
function TppMainPerso.D(iRange : integer):integer;
begin
  D := Random(iRange) + 1;
end;

(**************************************************************************)
{fonction du jet d'un d spcial 1-4=1 5-7=2 8-9=3 10=4}
function TppMainPerso.D4:integer;
begin
  case D(10) of
    1..4 : D4 := 1 ;
    5..7 : D4 := 2 ;
    8..9 : D4 := 3 ;
    10   : D4 := 4 ;
  end ;
end;

(**************************************************************************)
{soustrait la probabilit et enlve 1 au compteur de cette table}
procedure TppMainPerso.tblSlave_BeforeDelete(DataSet: TDataSet);
var
  i,j,k : integer;
begin
  tblMaster_.edit;
  i := tblMaster_.FieldByName('NbrElement').asInteger ;
  j := tblMaster_.FieldByName('TotProba').asInteger ;
  k := tblSlave_.FieldByName('Proba').asInteger ;
  tblMaster_.FieldByName('NbrElement').asInteger := i - 1 ;
  tblMaster_.FieldByName('TotProba').asInteger := j - k;
  tblMaster_.post;
  tblMaster_.Refresh;
end;

(**************************************************************************)
{visualisation du contenu de la table ppPerso, appel du rapport}
procedure TppMainPerso.btnImprimePersoClick(Sender: TObject);
begin
  ppPersoReport.qrePerso.Preview;
  queCount.Close;
  queCount.Open;
end;

(**************************************************************************)
{mise  jour des donnes de la table matre}
procedure TppMainPerso.tblSlave_AfterEdit(DataSet: TDataSet);
var
  iTotProb, iNbrElem : integer;
begin
  tblMaster_.First;
  while not tblMaster_.EOF do begin
    tblSlave_.Filtered := FALSE;
    SlaveRefresh;
    tblSlave_.First;
    iTotProb := 0;
    iNbrElem := 0;
    while not tblSlave_.EOF do begin
      inc(iTotProb , tblSlave_Proba.asInteger);
      inc(iNbrElem);
      tblSlave_.next;
    end;
    tblMaster_.Edit;
    tblMaster_.FieldByName('NbrElement').asInteger := iNbrElem;
    tblMaster_.FieldByName('TotProba').asInteger := iTotProb;
    tblMaster_.Post;
    tblMaster_.Next;
  end;
  tblMaster_.Refresh;

end;

(**************************************************************************)
{mise  jour des donnes de la table matre}
procedure TppMainPerso.btnRafraichirClick(Sender: TObject);
var
  iTotProb, iNbrElem : integer;
begin
  tblMaster_.First;
  while not tblMaster_.EOF do begin
    tblSlave_.Filtered := FALSE;
    SlaveRefresh;
    tblSlave_.First;
    iTotProb := 0;
    iNbrElem := 0;
    while not tblSlave_.EOF do begin
      inc(iTotProb , tblSlave_Proba.asInteger);
      inc(iNbrElem);
      tblSlave_.next;
    end;
    tblMaster_.Edit;
    tblMaster_.FieldByName('NbrElement').asInteger := iNbrElem;
    tblMaster_.FieldByName('TotProba').asInteger := iTotProb;
    tblMaster_.Post;
    tblMaster_.Next;
  end;
  tblMaster_.Refresh;
end;

(**************************************************************************)
{gnration d'un trsor, sauvegarde dans la table ppTresor}
procedure TppMainPerso.btnTresorClick(Sender: TObject);
var
  sSpec, sTres : string;
  sChoix : string[4];
  iCle, i, j : integer;
begin
  queCount.SQL.Clear;
  queCount.SQL.Add('SELECT COUNT(*) as NonImprime FROM ppTresor WHERE DateImprime IS NULL');
  queCount.Close;
  dbgMaster.Visible := FALSE;
  dbgSlave.Visible := FALSE;
  dbgSlave.Enabled := FALSE;
  dbgMaster.Enabled := FALSE;
  memPerso.Clear;
  with memPerso.Lines do begin
    iCle := tblTresor_.RecordCount;
    sTres := PP('tytr'); {choix du type de trsor}
    Add ('PP -'+ IntToStr(iCle) + '- ' + DateToStr(Date)) ;
    sSpec := PP(Copy(sTres,1,4)); {choix dans sous-table des trsors}

    sChoix := Copy(sTres,1,4); {traitements spcifiques}

    if sChoix = 'trjo' then begin {joyaux}
      sSpec := sSpec + ' - TAILLE: ' + PP('trjt') + ' - RARETE: ' + PP('trjr') + ' - VALEUR(+EL): x' + IntToStr(D(100)) ;
    end;

    if sChoix = 'trop' then begin {matriau de l'objet prcieux}
      sSpec := sSpec + ' - EN: ' + PP('trom')
    end;

    if sChoix = 'trmo' then begin {monnaie}
      sSpec := Copy(sSpec,5,Length(sSpec)) + ' - QT: ' + IntToStr(D(StrToInt(Copy(sSpec,1,3))));
    end;

    if sChoix = 'trar' then begin {partie d'armure}
      sSpec := sSpec + ' - SUR: ' + PP('trac')
    end;

    if sChoix = 'trma' then begin {magique}
      i := D(10);
      case i of
        1..4 : j := D(6);
        5..7 : j := D(6)+D(6);
        8..9 : j := D(6)+D(6)+D(6);
        10   : j := D(6)+D(6)+D(6)+D(6);
      end;
      sSpec := sSpec + ' - MEL ' + IntToStr(j);
      i := D(10);
      sSpec := sSpec + ' / EL ' + IntToStr(i);
      sSpec := sSpec + ' - EFFET: ' + PP('trme');
      if D(10)=1 then begin
        sSpec := sSpec + ' / ' + PP('trme');
      end;
      if D(10)=1 then begin
        sSpec := sSpec + ' / ' + PP('trme');
      end;
     end;

    if (sChoix = 'trar') or (sChoix = 'trae')
    or (sChoix = 'trmg') or (sChoix = 'tran') then begin {quantit d'objets militaires}
      sSpec := sSpec + ' - QT: ' + PP('traq')
    end;

    {divers paramtres}
    Add( Copy(sTres,6,Length(sTres)) + ' - ' + sSpec);
    Add('PROTECTION: ' + PP('trpr')+
    ' - VISIBLE: '  + PP('trvi') +
    ' - ORIGINE: ' + PP('tror') );
    Add('QT: ' + PP('trqt') +
    ' - EL: ' + PP('trql') +
    ' - ETAT: ' + PP('tret') +
    ' - CONTENANT: ' + PP('trcn') );
  end;
  memPerso.Refresh;
  dbgSlave.Visible := TRUE;
  dbgMaster.Visible := TRUE;
  tblTresor_.Append;
  tblTresor_.FieldByName('ID').asInteger := iCle;
  tblTresor_.FieldByName('Tresor').asString := memPerso.Text;
  tblTresor_.FieldByName('DateCreation').asDateTime := Now;
  sSpec := ' ';
  tblTresor_.FieldByName('Type').asString := sSpec;
  tblTresor_.Post;
  queCount.Open;

end;

(**************************************************************************)
{rapport pour trsor}
procedure TppMainPerso.btnImprimeTresorClick(Sender: TObject);
begin
  ppReportTresor.qreTresor.Preview;
  queCount.Close;
  queCount.Open;

end;

(**************************************************************************)
{cration d'une rencontre}
procedure TppMainPerso.btnRencontreClick(Sender: TObject);
var
  sSpec, sTres : string;
  sChoix : string;
  iCle, i, j, k : integer;
begin
  i := D(10); {nombre d'lments pour l'vnement}
  case i of
    1..4 : j :=1;
    5..7 : j :=2;
    8..9 : j :=3;
    10   : j :=4;
  end;
  queCount.SQL.Clear;
  queCount.SQL.Add('SELECT COUNT(*) as NonImprime FROM ppRencontre WHERE DateImprime IS NULL');
  queCount.Close;
  dbgMaster.Visible := FALSE;
  dbgSlave.Visible := FALSE;
  dbgSlave.Enabled := FALSE;
  dbgMaster.Enabled := FALSE;
  memPerso.Clear;
  with memPerso.Lines do begin
    iCle := tblRencontre_.RecordCount;
    Add ('PP -'+ IntToStr(iCle) + '- ' + DateToStr(Date)) ;
    for i := 1 to j do begin
      sChoix := PP('renc');
      sSpec := Copy(sChoix, 6, length(sChoix));
      sChoix:= Copy(sChoix, 1, 4);

      if sChoix='rcre' then begin {crature}
        Add(PP('rnom') + ' ' + sSpec + ' - FORME: '
          + PP('rfor') + ' - ALIGNEMENT: ' + PP('rali') );
        Add('  ATTITUDE: ' + PP('ratt') + ' - VISIBILITE: ' + PP('trvi') + ' - ACTIVITE: ' + PP('ract') );
      end;

      if sChoix='rhum' then begin {humain}
        Add(PP('rnom') + ' ' + sSpec + ' - ALIGNEMENT: ' + PP('rali')  +
          ' - SOCIAL: ' + PP('rich')  + ' ORIGINE: ' + PP('orig') );
        Add('  ATTITUDE: ' + PP('ratt')
           +' - VISIBILITE: ' + PP('trvi') + ' - ACTIVITE: ' + PP('ract') );
      end;

      if sChoix='rani' then begin {animal}
        Add(PP('rnom') + ' ' + sSpec + ' - FORME: ' + PP('rfor') );
        Add('   - OBJECTIF: ' + PP('ratt') +' - VISIBILITE: '
          + PP('trvi') + ' - ACTIVITE: ' + PP('ract') );
      end;

      if sChoix='rcon' then begin {construction/lieu}
        for k := 1 to D(3) do begin
          Add(sSpec +': '+ PP('rcon') + ' - TAILLE: ' + PP('rtai') +
           ' - VISIBILITE: ' + PP('trvi') + ' - ETAT: ' + PP('tret') );
        end;
      end;

      if sChoix='rmet' then begin {mto}
          Add(sSpec +': '+ PP('rmet') + ' - POSITIVITE: ' + PP('rpos') );
      end;

      if sChoix='rter' then begin {terrain}
        for k := 1 to D(5) do begin
          Add(sSpec +': '+ PP('rter') + ' - TAILLE: ' + PP('rtai') +
           ' - VISIBILITE: ' + PP('trvi') );
        end;
      end;

      if sChoix='reve' then begin {vnement}
        for k := 1 to D(3) do begin
          Add(sSpec +': '+ PP('reve') + ' - POSITIVITE: ' + PP('rpos')  );
        end;
      end;

      if sChoix='robj' then begin {objet}
        for k := 1 to D(3) do begin
          sChoix := PP('tytr');
          Add(sSpec +': '+ Copy(sChoix, 6, length(sChoix)) + ' - TAILLE: ' + PP('rtai') +
           ' - VISIBILITE: ' + PP('trvi') + ' - ETAT: ' + PP('tret') );
        end;
      end;
      Add('............');
    end;
  end;
  memPerso.Refresh;
  dbgSlave.Visible := TRUE;
  dbgMaster.Visible := TRUE;
  tblRencontre_.Append;
  tblRencontre_.FieldByName('ID').asInteger := iCle;
  tblRencontre_.FieldByName('Rencontre').asString := memPerso.Text;
  tblRencontre_.FieldByName('DateCreation').asDateTime := Now;
  sSpec := ' ';
  tblRencontre_.FieldByName('Type').asString := sSpec;
  tblRencontre_.Post;
  queCount.Open;
end;

(**************************************************************************)
procedure TppMainPerso.btnPrintRencontreClick(Sender: TObject);
begin
  frmReportRencontre.qreRencontre.preview;
  queCount.Close;
  queCount.Open;
end;

(**************************************************************************)
{cration d'un village}
procedure TppMainPerso.btnVillageClick(Sender: TObject);
var
  sSpec, sVill, sCons : string;
  sChoix, sProf : string;
  iCle, i, j, k , nMais, nPop : integer;
begin
  queCount.SQL.Clear;
  queCount.SQL.Add('SELECT COUNT(*) as NonImprime FROM ppVillage WHERE DateImprime IS NULL');
  queCount.Close;
  dbgMaster.Visible := FALSE;
  dbgSlave.Visible := FALSE;
  dbgSlave.Enabled := FALSE;
  dbgMaster.Enabled := FALSE;
  memPerso.Clear;
  sVill := PP('vino');
  sCons := PP('vico');
  nMais := D(D4 * 10) +  D(D4*10) +  D(D4*10)+  D(D4*10);
  nPop  := (D4 + D4 + D4 - 2) * nMais ;
  with memPerso.Lines do begin
    iCle := tblVillage_.RecordCount;
    Add ('PP -'+ IntToStr(iCle) + '- ' + DateToStr(Date)) ;
    Add ('NOM(' + sVill + ')__________ CONSTRUIT(' + sCons + ')__________ REGION(' + PP('vire') + ')__________');
    Add ('MAISONS >>> ' + IntToStr(nMais) + ' <<<  POPULATION >>> ' + IntToStr(nPop) + ' <<<  (' + PP('viag') + ' / ' + PP('vica') + ')');
    Add ('SEIGNEUR(' + PP('vise') + ' / ' + PP('virp') + ')__________ FAMILLE(' + PP('vifa') + ')__________ ');
    Add ('FIEF (' + PP('vifi') + ')____________________  VASSAL(' + PP('viva') + ')____________________');
    Add ('INTENDANTS(' + PP('viin') + ' / ' + IntToStr( D( (D4-1)*3 ) ) + ')______________________________');
    Add ('HOMMES d ARMES (' + PP('viha') + ' / ' + IntToStr( D(D4*10) ) + ')______________________________');
    Add ('CHEVALIER(' + PP('vich') + ' / ' + IntToStr( D( (D4-1)*4 ) ) + ')______________________________');
    Add ('IMPOTS LOCAUX(' + PP('viim') + ')__________' + 'LOIS(' + PP('vilo') + ')____________________');
    Add ('HISTOIRES / LEGENDES(' + PP('vihi') + ')________________________________________');
    Add ('>');
    Add ('>');
    Add ('LIEU EN : ' + PP('vifo') + '__________  PROTEGE PAR : ' + PP('vipr') + '__________' );
    sChoix := '';
    for k := 1 to D4 + D4 - 1 do begin
      sChoix := sChoix + PP('viel') + ' / ';
    end;
    Add ('TERRAIN : ' + sChoix + '__________    ');
    Add ('DANGER : ' + PP('vida') );
    sChoix := '';
    for k := 1 to D4 - 1   do begin
      sChoix := sChoix + PP('viit') + ' / ';
    end;
    Add ('RICHESSE : ' + PP('viri') + '    INTERETS LOCAUX : ' + sChoix + '    MARCHE : ' + PP('vima') );
    for k := 1 to D4 - 1  do begin
      Add ('RESSOURCE : ' + PP('virs') + '____________________________' );
    end;
    Add ('> METIERS : ');
    sSpec := '';
    j := Round((50 + D(20)) * nMais * 0.01);
    if j > nPop/2 then j := D(Round(nPop/2)); {vrifie qu'il n'y pas trop de mtiers}
    for k := 1 to j do begin
      sChoix := Copy('   ', 1, 2 - Length(IntToStr(k)) ) + IntToStr(k);
      sProf  := PP('vime');
      sSpec  := sSpec + sChoix + '-' + sProf + Copy('            ', 1, 13 - Length(sProf));
    end;
    Add (sSpec );


  end;
  memPerso.Refresh;
  dbgSlave.Visible := TRUE;
  dbgMaster.Visible := TRUE;
  tblVillage_.Append;
  tblVillage_.FieldByName('ID').asInteger := iCle;
  tblVillage_.FieldByName('Village').asString := memPerso.Text;
  tblVillage_.FieldByName('DateCreation').asDateTime := Now;
  tblVillage_.FieldByName('Type').asString := 'A' + sCons + 'M' + IntToStr(nMais);
  tblVillage_.Post;
  queCount.Open;

end;
(**************************************************************************)
{appel pour l'impression des villages}
procedure TppMainPerso.btnImprimeVillageClick(Sender: TObject);
begin
  ppReportVillage.qreVillage.qreVillage.Preview;
  queCount.Close;
  queCount.Open;
end;

end.
